import Migration, { MigrationFunction } from '@watermarkchurch/contentful-migration'

// Generated by contentful-schema-diff
// from empty-export.json
// to   7yx6ovlj39n5
export = function(migration : Migration, { makeRequest, spaceId, accessToken }) {

  /************  section-block-text  ******************/

  var sectionBlockText = migration.createContentType('section-block-text', {
    displayField: 'internalTitle',
    name: 'Section: Block Text',
    description: 'Markdown free-text block'
  })

  sectionBlockText.createField('internalTitle', {
    name: 'Internal Title (Contentful Only)',
    type: 'Symbol',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: true
  })

  sectionBlockText.createField('body', {
    name: 'Body',
    type: 'Text',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionBlockText.changeEditorInterface('internalTitle', 'singleLine')

  sectionBlockText.changeEditorInterface('body', 'markdown')

} as MigrationFunction
