import Migration, { MigrationFunction } from '@watermarkchurch/contentful-migration'

// Generated by contentful-schema-diff
// from empty-export.json
// to   7yx6ovlj39n5
export = function(migration : Migration, { makeRequest, spaceId, accessToken }) {

  /************  section-http-error  ******************/

  var sectionHttpError = migration.createContentType('section-http-error', {
    displayField: 'internalTitle',
    name: 'Section: Http Error',
    description: ''
  })

  sectionHttpError.createField('internalTitle', {
    name: 'Internal Title (Contentful Only)',
    type: 'Symbol',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: true
  })

  sectionHttpError.createField('errorCode', {
    name: 'Error Code',
    type: 'Integer',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionHttpError.createField('text', {
    name: 'Text',
    type: 'Text',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionHttpError.createField('actionButton', {
    name: 'Action Button',
    type: 'Array',
    localized: false,
    required: false,
    validations: [],
    disabled: false,
    omitted: false,
    items:
    {
      type: 'Link',
      validations: [{ linkContentType: ['menuButton'] }],
      linkType: 'Entry'
    }
  })

  sectionHttpError.createField('backgroundImage', {
    name: 'Background Image',
    type: 'Link',
    localized: false,
    required: true,
    validations:
      [{
        linkMimetypeGroup: ['image'],
        message: 'Must be an image'
      }],
    disabled: false,
    omitted: false,
    linkType: 'Asset'
  })

  sectionHttpError.changeEditorInterface('internalTitle', 'singleLine')

  sectionHttpError.changeEditorInterface('errorCode', 'numberEditor')

  sectionHttpError.changeEditorInterface('text', 'markdown')

  sectionHttpError.changeEditorInterface('actionButton', 'entryLinksEditor', { bulkEditing: false })

  sectionHttpError.changeEditorInterface('backgroundImage', 'assetLinkEditor')

} as MigrationFunction
