import Migration, { MigrationFunction } from '@watermarkchurch/contentful-migration'

// Generated by contentful-schema-diff
// from empty-export.json
// to   7yx6ovlj39n5
export = function(migration : Migration, { makeRequest, spaceId, accessToken }) {

  /************  section-video-highlight  ******************/

  var sectionVideoHighlight = migration.createContentType('section-video-highlight', {
    displayField: 'internalTitle',
    name: 'Section: Video Highlight',
    description: 'Highlight a video with some text'
  })

  sectionVideoHighlight.createField('internalTitle', {
    name: 'Internal Title (Contentful Only)',
    type: 'Symbol',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: true
  })

  sectionVideoHighlight.createField('tag', {
    name: 'Tag',
    type: 'Symbol',
    localized: true,
    required: false,
    validations:
      [{
        size: { min: 0, max: 75 },
        message: 'Tag must be short!'
      }],
    disabled: false,
    omitted: false
  })

  sectionVideoHighlight.createField('title', {
    name: 'Title',
    type: 'Symbol',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionVideoHighlight.createField('subtext', {
    name: 'Subtext',
    type: 'Text',
    localized: true,
    required: false,
    validations: [{ size: { min: 0, max: 500 } }],
    disabled: false,
    omitted: false
  })

  sectionVideoHighlight.createField('embedCode', {
    name: 'Embed Code',
    type: 'Text',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionVideoHighlight.changeEditorInterface('tag', 'singleLine')

  sectionVideoHighlight.changeEditorInterface('title', 'singleLine')

  sectionVideoHighlight.changeEditorInterface('subtext', 'markdown')

  sectionVideoHighlight.changeEditorInterface('embedCode', 'markdown')

  sectionVideoHighlight.changeEditorInterface('internalTitle', 'singleLine')

} as MigrationFunction
