import Migration, { MigrationFunction } from '@watermarkchurch/contentful-migration'

// Generated by contentful-schema-diff
// from empty-export.json
// to   7yx6ovlj39n5
export = function(migration : Migration, { makeRequest, spaceId, accessToken }) {

  /************  section-video  ******************/

  var sectionVideo = migration.createContentType('section-video', {
    displayField: 'internalTitle',
    name: 'Section: Video',
    description: 'Full width video with a title'
  })

  sectionVideo.createField('internalTitle', {
    name: 'Internal Title (Contentful Only)',
    type: 'Symbol',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: true
  })

  sectionVideo.createField('title', {
    name: 'Title',
    type: 'Symbol',
    localized: true,
    required: false,
    validations:
      [{
        size:
        {
          max: 255,
          min: 0
        }
      }],
    disabled: false,
    omitted: false
  })

  sectionVideo.createField('embedCode', {
    name: 'Embed Code',
    type: 'Text',
    localized: false,
    required: true,
    validations: [],
    disabled: false,
    omitted: false
  })

  sectionVideo.createField('style', {
    name: 'Style',
    type: 'Symbol',
    localized: false,
    required: false,
    validations:
      [{
        in:
          ['off white',
            'default',
            'gray']
      }],
    disabled: false,
    omitted: false
  })

  sectionVideo.changeEditorInterface('title', 'singleLine')

  sectionVideo.changeEditorInterface('embedCode', 'markdown')

  sectionVideo.changeEditorInterface('internalTitle', 'singleLine')

  sectionVideo.changeEditorInterface('style', 'dropdown')

} as MigrationFunction
